            #GIT_CMT=11e5f2c198ff5eb0a7bccf3db50830bfcdedb3ba
%define uek2epoch 2
%define uek4epoch 4
%define uek5epoch 5

%define RELEASE 1.0.10
%{?el7:%define uektag uek4}

Name: ibacm
Epoch: %{uek4epoch}
Version: 1.2.1
Release: %{RELEASE}%{?dist}%{?uektag}
Summary: InfiniBand Communication Manager Assistant

Group: System Environment/Daemons
License: GPLv2 or BSD
Url: http://www.openfabrics.org/
Source0: ibacm-1.2.1.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: autoconf, libtool
BuildRequires: pkgconfig
BuildRequires: pkgconfig(libnl-3.0)
BuildRequires: pkgconfig(libnl-route-3.0)
BuildRequires: libibverbs-devel >= %{uek4epoch}:1.1.8-1.0.1
BuildRequires: libibverbs-devel < %{uek5epoch}:0
BuildRequires: libibumad-devel >= %{uek4epoch}:1.3.10.2-1.0.1
BuildRequires: libibumad-devel < %{uek5epoch}:0

%{?el6:Requires: libnl3 >= 3.2.21-8.0.1}

Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
ExcludeArch: s390, s390x

%description
The %{name} daemon helps reduce the load of managing path record lookups on
large InfiniBand fabrics by providing a user space implementation of what
is functionally similar to an ARP cache.  The use of %{name}, when properly
configured, can reduce the SA packet load of a large IB cluster from O(n^2)
to O(n).  The %{name} daemon is started and normally runs in the background,
user applications need not know about this daemon as long as their app
uses librdmacm to handle connection bring up/tear down.  The librdmacm
library knows how to talk directly to the %{name} daemon to retrieve data.

%package devel
Summary: Headers file needed when building apps to talk directly to ibacm.
Requires: %{name} = %{uek4epoch}:%{version}-%{release}
Group: System Environment/Daemons

%description devel
Most applications do not need to know how to talk directly to the ibacm
daemon, but it does have a socket that it listens on, and it has a
specific protocol for incoming/outgoing data.  So if you wish to build
the ability to communicate directly with %{name} into your own application,
the protocol used to communicate with it, and the data structures
involved, are in this header file.  Please note that this is an unsupported
method of using this daemon.  The only supported means of using this is
via librdmacm.  As such, even though this header file is provided, no
further documentation is available.  One must read the source if they
wish to make use of this header file.

%prep
%setup -q -n %{name}-%{version}

%build
mkdir -p config && aclocal -I config && libtoolize --force --copy && autoheader && \
	automake --foreign --add-missing --copy && autoconf
%configure\
	rdmascript="rdma"\
	CFLAGS="$CFLAGS -fno-strict-aliasing"\
	LDFLAGS="$LDFLAGS -lpthread"\
	IBACM_ACME_PLUS_KERNEL_ONLY_DEFAULT="true"
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
install -D -m 755 ibacm.init $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
%makeinstall

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}

%preun
/sbin/chkconfig --del %{name} || true

# Also adding a '%posttrans' section, as the old "ibacm" package
# erroneously removed the service 'ibacm' in its '%preun' section
# for upgrade "if [ $1 = 1 ]".
# This was probably a typo and meant to say "if [ $1 = 0 ]",
# doing it for the uninstall, and not for the upgrade!
# That's water under the bridge though....
# Since '%posttrans' is the only section from a new package
# that is executed AFTER both '%preun' and '%postun' of the
# old package, we do the fixup here.
%posttrans
/sbin/chkconfig --add %{name}

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%{_bindir}/ib_acme
%{_sbindir}/ibacm
%{_mandir}/man1/*
%{_mandir}/man7/*
%{_sysconfdir}/init.d/ibacm
%{_libdir}/ibacm/lib*.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/infiniband/acm.h
%{_includedir}/infiniband/acm_prov.h

%changelog
* Thu Jul 09 2020 Mark Haywood <mark.haywood@oracle.com> - 4:1.2.1-1.0.10
- BUILDINFO: commit=11e5f2c198ff5eb0a7bccf3db50830bfcdedb3ba
- treewide: Don't cast malloc() output (Mark Haywood) [Orabug: 31344804]
- ibacm: Fix format string warning on 32 bit compile (Mark Haywood) [Orabug: 31408034]
- ibacm: Remove libnl3 checks from configure.ac (Mark Haywood) [Orabug: 31402326]
- ibacm: remove include of net/if.h due to conflict (Mark Haywood) [Orabug: 31344968]
- ibacm: only open InfiniBand port (Mark Haywood) [Orabug: 31346292]
- ibacm: Fix a memory leak in an acm_open_dev() error path (Mark Haywood) [Orabug: 31346292]
- ibacm: Do not open non InfiniBand device (Mark Haywood) [Orabug: 31346292]

* Mon Dec 23 2019 Mark Haywood <mark.haywood@oracle.com> - 4:1.2.1-1.0.9
- Revert "ibacm: Compare logical partitions instead of pkeys" (Mark Haywood) [Orabug: 29181441]
- Compare logical partitions instead of pkeys (Mark Haywood) [Orabug: 29181441]
- Lower level of log message (Mark Haywood) [Orabug: 29181441]
- Revert "Unable to resurrect an interface" (Mark Haywood) [Orabug: 29181453]
- Replace ioctl with netlink (Mark Haywood) [Orabug: 29181453
- Print correct pkey (Mark Haywood)[Orabug: 29181453]
- Unable to resurrect an interface (Mark Haywood) [Orabug: 29181453]
- Use alias name when possible (Mark Haywood) [Orabug: 29181453]
- Use inttypes.h format string macros (Mark Haywood) [Orabug: 28976896]
- Remove trailing blanks in acm.h (Mark Haywood) [Orabug: 28976896]
- Remove dup defines and cleanup of hdr.data usage (Mark Haywood) [Orabug: 28976896]
- acme supports only one port (Mark Haywood) [Orabug: 28976896]
- Introduce acm_log_once() (Mark Haywood) [Orabug: 29325336]
- Fix acm_log_once (Mark Haywood) [Orabug: 29325336]
- Log requests from kernel with unknown NL client ID (Mark Haywood) [Orabug: 29319222]

* Wed Jan 16 2019 Aron Silverton <aron.silverton@oracle.com> - 4:1.2.1-1.0.8
- ACM_ADDRESS_NAME names missing terminating NULL character (Mark Haywood) [Orabug: 29181470]
- Compare logical partitions instead of pkeys (Mark Haywood) [Orabug: 29181441]
- Unable to resurrect an interface (Mark Haywood) [Orabug: 29181453]

* Wed Jan 09 2019 Aron Silverton <aron.silverton@oracle.com> - 4:1.2.1-1.0.7
- Log using RCF3339 timestamps (Matt Ezell) [Orabug: 28971668]
- remove endpoint IP address from provider when address deleted (Mark Haywood) [Orabug: 28744655]
- Check return value when deleting a cache entry (Håkon Bugge) [Orabug: 28931362]
- Flush cache in provider when local address is removed (Håkon Bugge) [Orabug: 28917198]
- Remove trailing blanks (Håkon Bugge) [Orabug: 28931638]
- Fix proper return value from ib_acme (Håkon Bugge) [Orabug: 28912323]
- Handle rereg event coming before link active event (Håkon Bugge) [Orabug: 28917077]
- Unable to assign EP name for limited pkey (Håkon Bugge) [Orabug: 28885651]
- Fix improper refcnt (Håkon Bugge) [Orabug: 28800874]
- Fix incorrect length used in address comparisons (Håkon Bugge) [Orabug: 28800890]
- Copy correct number of address bytes before calling provider (Håkon Bugge) [Orabug: 28800916]

* Tue Oct 02 2018 Aron Silverton <aron.silverton@oracle.com> - 4:1.2.1-1.0.6
- Backport "e2c3c3f Incorrect usage of..." (Mark Haywood) [Orabug: 28708370]

* Sat May 19 2018 Aron Silverton <aron.silverton@oracle.com> - 4:1.2.1-1.0.5
- Add Epoch to package versioning (Aron Silverton) [Orabug: 27593051]
- Add "uek4" token for OL7 package builds (Aron Silverton) [Orabug: 27934606]

* Tue May 15 2018 Aron Silverton <aron.silverton@oracle.com> - 1.2.1-1.0.4
- Fix ibacm service not starting on reboot (Gerd Rausch) [Orabug: 28011897]

* Wed May 02 2018 Aron Silverton <aron.silverton@oracle.com> - 1.2.1-1.0.3
- Generate autotools output at build time (Aron Silverton) [Orabug: 27959410]
- Backport fix for "empty port provider causes segfault" (Wei Lin Guay) [Orabug: 27646071]
- Adding new configuration option 'server_mode' (Gerd Rausch) [Orabug: 27767424]
- Adding new configuration option 'acme_plus_kernel_only' (Gerd Rausch) [Orabug: 27788257]

* Tue Feb 28 2012 Doug Ledford <dledford@redhat.com> - 1.0.5-1
- Ininital version for rhel6
- Related: bz700285
